aboutsummaryrefslogtreecommitdiff
path: root/applets
diff options
context:
space:
mode:
authorGravatar Denis Vlasenko <vda.linux@googlemail.com>2007-08-25 18:25:24 +0000
committerGravatar Denis Vlasenko <vda.linux@googlemail.com>2007-08-25 18:25:24 +0000
commit737d131e5e7a795ef771f987d7b02cbf4fa670d6 (patch)
tree0a7acc833d9ee4fa873ec4c15ff60b692bef420e /applets
parent52226771760063acdc89ef4f8e531b595ae4232b (diff)
downloadbusybox-737d131e5e7a795ef771f987d7b02cbf4fa670d6.tar.gz
busybox-737d131e5e7a795ef771f987d7b02cbf4fa670d6.tar.bz2
support "#!/bin/busybox"-style wrappers. Needed for SELinux.
Patch by Yuichi Nakamura <ynakam@hitachisoft.jp>
Diffstat (limited to 'applets')
-rw-r--r--applets/applets.c7
-rwxr-xr-xapplets/install.sh82
2 files changed, 53 insertions, 36 deletions
diff --git a/applets/applets.c b/applets/applets.c
index 6de6db3cd..c2040b9a3 100644
--- a/applets/applets.c
+++ b/applets/applets.c
@@ -600,9 +600,10 @@ static int busybox_main(char **argv)
/* "busybox <applet> arg1 arg2 ..." */
argv++;
}
- /* we want "<argv[0]>: applet not found", not "busybox: ..." */
- applet_name = argv[0];
- run_applet_and_exit(argv[0], argv);
+ /* We support "busybox /a/path/to/applet args..." too. Allows for
+ * "#!/bin/busybox"-style wrappers */
+ applet_name = bb_get_last_path_component(argv[0]);
+ run_applet_and_exit(applet_name, argv);
bb_error_msg_and_die("applet not found");
}
diff --git a/applets/install.sh b/applets/install.sh
index b02350262..e94b2b98e 100755
--- a/applets/install.sh
+++ b/applets/install.sh
@@ -5,19 +5,23 @@ export LC_CTYPE=POSIX
prefix=${1}
if [ -z "$prefix" ]; then
- echo "usage: applets/install.sh DESTINATION [--symlinks/--hardlinks]"
+ echo "usage: applets/install.sh DESTINATION [--symlinks/--hardlinks/--scriptwrapper]"
exit 1;
fi
h=`sort busybox.links | uniq`
+scriptwrapper="n"
cleanup="0"
noclobber="0"
case "$2" in
- --hardlinks) linkopts="-f";;
- --symlinks) linkopts="-fs";;
- --cleanup) cleanup="1";;
- --noclobber) noclobber="1";;
- "") h="";;
- *) echo "Unknown install option: $2"; exit 1;;
+ --hardlinks) linkopts="-f";;
+ --symlinks) linkopts="-fs";;
+ --scriptwrapper) scriptwrapper="y";swrapall="y";;
+ --sw-sh-hard) scriptwrapper="y";linkopts="-f";;
+ --sw-sh-sym) scriptwrapper="y";linkopts="-fs";;
+ --cleanup) cleanup="1";;
+ --noclobber) noclobber="1";;
+ "") h="";;
+ *) echo "Unknown install option: $2"; exit 1;;
esac
if [ -n "$DO_INSTALL_LIBS" ] && [ "$DO_INSTALL_LIBS" != "n" ]; then
@@ -52,6 +56,7 @@ if [ "$cleanup" = "1" ] && [ -e "$prefix/bin/busybox" ]; then
cd "$pd"
done
`
+ exit 0
fi
rm -f $prefix/bin/busybox || exit 1
@@ -61,33 +66,44 @@ install -m 755 busybox $prefix/bin/busybox || exit 1
for i in $h; do
appdir=`dirname $i`
mkdir -p $prefix/$appdir || exit 1
- if [ "$2" = "--hardlinks" ]; then
- bb_path="$prefix/bin/busybox"
- else
- case "$appdir" in
- /)
- bb_path="bin/busybox"
- ;;
- /bin)
- bb_path="busybox"
- ;;
- /sbin)
- bb_path="../bin/busybox"
- ;;
- /usr/bin|/usr/sbin)
- bb_path="../../bin/busybox"
- ;;
- *)
- echo "Unknown installation directory: $appdir"
- exit 1
- ;;
- esac
- fi
- if [ "$noclobber" = "0" ] || [ ! -e "$prefix$i" ]; then
- echo " $prefix$i -> $bb_path"
- ln $linkopts $bb_path $prefix$i || exit 1
+ if [ "$scriptwrapper" = "y" ]; then
+ if [ "$swrapall" != "y" ] && [ "$i" = "/bin/sh" ]; then
+ ln $linkopts busybox $prefix$i || exit 1
+ else
+ rm -f $prefix$i
+ echo "#!/bin/busybox" > $prefix$i
+ chmod +x $prefix/$i
+ fi
+ echo " $prefix$i"
else
- echo " $prefix$i already exists"
+ if [ "$2" = "--hardlinks" ]; then
+ bb_path="$prefix/bin/busybox"
+ else
+ case "$appdir" in
+ /)
+ bb_path="bin/busybox"
+ ;;
+ /bin)
+ bb_path="busybox"
+ ;;
+ /sbin)
+ bb_path="../bin/busybox"
+ ;;
+ /usr/bin|/usr/sbin)
+ bb_path="../../bin/busybox"
+ ;;
+ *)
+ echo "Unknown installation directory: $appdir"
+ exit 1
+ ;;
+ esac
+ fi
+ if [ "$noclobber" = "0" ] || [ ! -e "$prefix$i" ]; then
+ echo " $prefix$i -> $bb_path"
+ ln $linkopts $bb_path $prefix$i || exit 1
+ else
+ echo " $prefix$i already exists"
+ fi
fi
done